import json

"""
This helper class loads up the configuration file and serves its data

The data is:
ip, port : our local address
LISTEN_READ_BYTES: the bytes the listener will try to read at an incoming connection
MAX_SIMULTANEOUS_CONNECTIONS: how many incoming connections do we accept simultaneously
LISTEN_TIMEOUT_SECONDS: timeout for the listener i.e it will drop client connection if nothing happens for this many seconds)
"SERVER_SEND_PACKAGE_SIZE": How big chunks the server will use to send back data, don't put it too high or you'll choke some buffers here

"""


class Configuration:
    def __init__(self):
        with open('config.json', 'r') as f:
            self.data = json.load(f)

    def get(self, name, default=None):
        if name in self.data:
            return self.data[name]
        return default
