import sys
import os

from Crypto.Cipher import AES
from Crypto.Util import Counter
from Crypto import Random
import binascii
import os.path
import tarfile

import database_connection as dc
import database_query as dq

from encryption import CipherHelper


if len(sys.argv) == 1:
    print('Usage: for when an already shared data has changed')
    print('')
    print('python3 update_data.py dataname filefolder file')
    print('python3 update_data.py -f dataname filefolder')
    print('')
    print('Example:')
    print('python3 update_data.py flower home/other_images flower2.jpg')
    print('Note: the original filename will not be changed, flower.jpg will be downloaded by users, not flower2.jpg')
    print(' but its content will reflect flower2.jpg')

    exit()

"""
"""


def chomp(x):
    if x.endswith("\r\n"): return x[:-2]
    if x.endswith("\n") or x.endswith("\r"): return x[:-1]
    return x


def update_our_data(name, filefolder, file, rsa_pub_key):
    connection = dc.get_connection()

    print('Update data:')

    filepath = os.path.join(filefolder, file)

    with open(filepath, 'rb') as f:
        data = f.read()

    if data is None:
        print('File not found')
        exit(-3)

    cursor = connection.cursor()
    cursor.execute("SELECT KEY, IV FROM data_owned WHERE NAME = '" + name + "'")
    rows = cursor.fetchall()
    # Does a database entry exists?
    if len(rows) <= 0:
        print("#Error entry does not exist (refresh_data) use insert_data.py instead")
        exit(0)
    # Get IV, KEY
    row = rows[0]
    key = bytes.fromhex(chomp(row[0]))
    iv = bytes.fromhex(chomp(row[1]))
    ch = CipherHelper(aes_key=key, raw_iv=iv)

    # Encrypt with AES-CTR
    encrypted_data = ch.encrypt(data)

    # Make a 'local' folder if it doesn't already exist (this should already exist)
    directory = 'data/local/'
    if not os.path.exists(directory):
        os.makedirs(directory)

    # Store the encypted data in the data folder so listener can serve it to clients:
    with open(directory + name + '.aes', 'wb') as f:
        f.write(encrypted_data)

    # Delete the stale data:
    #cursor.execute("DELETE FROM data_owned WHERE NAME = '" + name + "';")
    #connection.commit()

    #AEShex = ch.aes_key.hex()
    #IVhex = ch.raw_iv.hex()

    # Update the data version:
    cursor.execute("UPDATE data_owned SET data_version=data_version+1 WHERE NAME = ? ;", (name, ))
    connection.commit()

    # Now send the data to nodes having the old version by looping fingers and set them stale/try to send right away
    #"UPDATE finger SET data_version=data_version+1 WHERE "






if len(sys.argv) >= 4:
    prv, pub = dq.get_rsa_hex_keys()
    if sys.argv[1] == '-f':
        print('Update folder')
        regex = '.*'
        if len(sys.argv) == 5:
            regex = sys.argv[4]
        folder = sys.argv[3]
        # get all the files in 'folder' and zip it:
        data_name = sys.argv[2]
        full_data_name = data_name + '.tar.gz'
        with tarfile.open(full_data_name, "w:gz") as tar_handle:
            tar_handle.add(folder)

        print('Insert new folder link')
        # name, filefolder, file, rsa_pub_key
        update_our_data(data_name, './', full_data_name, pub)  # Local owned link

    else:
        print('Update existing link')
        # name, filefolder, file, rsa_pub_key
        update_our_data(sys.argv[1], sys.argv[2], sys.argv[3], pub)  # Local owned link












